package com.storlead.user.util;

import io.jsonwebtoken.Claims;
import io.jsonwebtoken.JwtException;
import io.jsonwebtoken.Jwts;
import io.jsonwebtoken.SignatureAlgorithm;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import java.time.Duration;
import java.util.Date;


/**
 * JWT工具类
 *
 * @author blank
 * @date 2020-12-30 下午 5:26
 */
@Slf4j
@Component
public class UserJwtUntil {

//    @Value("${spring.security.jwt.expiryInHours}")
    public Integer expiryInHours = 2400;

    /**
     * 过期时间
     * dev 100天
     * test prod 10小时
     */

//    @Value("${spring.security.jwt.secretKey}")
    public String secretKey = "VzMzUUNCY0g2cnRVQkR6OU5kTnVUY2tkZWlodFdkc0dpdVRwTmk4dnRWc2lKYmllRnEyekVLV29NWEJIM2IzSm1wRllacWdndFZmZFY0UTk0RmhxQm4zR1R4";

    /**
     * 生成JWT
     *
     * @param username 用户名
     * @return java.lang.String
     * @author blank
     * @date 2020-12-30 下午 5:30
     */
    public String generate(String username) {

        return Jwts.builder()
                //将用户名放进JWT
                .setSubject(username)
                //设置JWT签发时间
                .setIssuedAt(new Date())
                //设置过期时间
                .setExpiration(new Date(System.currentTimeMillis() + Duration.ofHours(expiryInHours).toMillis()))
                //设置加密算法和密钥
                .signWith(SignatureAlgorithm.HS512, secretKey)
                .compact();
    }

    /**
     * 解析JWT
     *
     * @param token JWT字符串
     * @return io.jsonwebtoken.Claims
     * @author blank
     * @date 2020-12-30 下午 5:30
     */
    public Claims parse(String token) {
        // 如果是空字符串直接返回null
        if (!StringUtils.hasLength(token)) {
            return null;
        }

        Claims claims = null;
        // 解析失败了会抛出异常, 所以我们要捕捉一下. token 过期 非法 都会导致解析失败
        try {
            claims = Jwts.parser()
                    .setSigningKey(secretKey)
                    .parseClaimsJws(token)
                    .getBody();
        } catch (JwtException e) {
            log.error("token解析失败:{}", e.toString());
        }
        return claims;
    }
}
